package com.futu.course.course.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.futu.course.common.entity.R;
import com.futu.course.course.domain.Course;
import com.futu.course.course.service.CourseService;
import com.futu.course.course.mapper.CourseMapper;

import com.futu.course.orders.domain.Order1;
import com.futu.course.orders.domain.OrderItem;
import com.futu.course.orders.mapper.Order1Mapper;
import com.futu.course.orders.mapper.OrderItemMapper;
import com.futu.course.user.domain.User;
import org.elasticsearch.common.util.LongHash;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;


/**
 * @author yuu
 * @description 针对表【course(课程表)】的数据库操作Service实现
 * @createDate 2025-05-05 18:45:13
 */
@Service
public class CourseServiceImpl extends ServiceImpl<CourseMapper, Course> implements CourseService {

    @Resource
    private RedisTemplate redisTemplate;

    @Resource
    private Order1Mapper order1Mapper;

    @Resource
    private OrderItemMapper orderItemMapper;


//    查询首页的课程
    @Override
    public R findAll() {

        User user = (User) redisTemplate.opsForValue().get("user");

        List<Long> order1Id = order1Mapper.selectObjs(new QueryWrapper<Order1>().eq("user_id", user.getId()).select("id").eq("status",1));

        List<Long>  orderItemId=new ArrayList<>();
        for (Long id:order1Id){
            OrderItem orderItem = orderItemMapper.selectOne(new QueryWrapper<OrderItem>().eq("order_id", id));
            orderItemId.add(orderItem.getCourseId());
        }
        List<Course> courses=new ArrayList<>();
        for (Long courseId:orderItemId){
            courses.add(this.baseMapper.selectOne(new QueryWrapper<Course>().eq("id",courseId)));
        }
        return R.ok(courses);
    }






}




