package com.futu.course.cupons.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.futu.course.common.entity.R;
import com.futu.course.course.domain.Course;
import com.futu.course.course.mapper.CourseMapper;
import com.futu.course.cupons.domain.Coupon;
import com.futu.course.cupons.dto.CouponDto;
import com.futu.course.cupons.service.CouponService;
import com.futu.course.cupons.mapper.CouponMapper;
import com.futu.course.orders.mapper.Order1Mapper;
import com.futu.course.user.domain.User;
import com.futu.course.user.domain.UserCoupon;
import com.futu.course.user.mapper.UserCouponMapper;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;

/**
* @author yuu
* @description 针对表【coupon(优惠券)】的数据库操作Service实现
* @createDate 2025-05-05 18:53:35
*/
@Service
public class CouponServiceImpl extends ServiceImpl<CouponMapper, Coupon>
    implements CouponService{

    @Resource
    private UserCouponMapper userCouponMapper;

    @Resource
    private RedisTemplate redisTemplate;


    @Resource
    private Order1Mapper order1Mapper;

    @Resource
    private CourseMapper courseMapper;


    @Override
    public R findAll(CouponDto primary) {
        User user = (User) redisTemplate.opsForValue().get("user");
        List<Long> objects = userCouponMapper.selectObjs(new QueryWrapper<UserCoupon>().eq("user_id", user.getId()).eq("status", 0).select("coupon_id"));
        if (objects == null){
            return R.failed("没有优惠券");
        }
        System.err.println(objects);
        Course course = courseMapper.selectById(primary.getCouponId());
        List<Coupon> list=new ArrayList<>();
        for (Long i:objects){
            list.add(this.baseMapper.selectOne(new QueryWrapper<Coupon>().eq("id",i).ge("condition_amount",course.getPrice())));
            System.err.println(list);
        }
        if (list==null){
            return R.failed("没有可用的优惠券");
        }
        return R.ok(list);
    }




}




